Index: trunk/kernel/kern/process.c
===================================================================
--- trunk/kernel/kern/process.c	(revision 690)
+++ trunk/kernel/kern/process.c	(revision 1)
@@ -1103,502 +384,153 @@
 
 ///////////////////////////////////////////
-char * process_fd_type_str( uint32_t type )
-{
-    switch( type )
-    {
-        case FILE_TYPE_REG : return "FILE";
-        case FILE_TYPE_DIR  : return "DIR";
-        case FILE_TYPE_FIFO : return "FIFO";
-        case FILE_TYPE_PIPE : return "PIPE";
-        case FILE_TYPE_SOCK : return "SOCK";
-        case FILE_TYPE_DEV  : return "DEV";
-        case FILE_TYPE_BLK  : return "BLK";
-        case FILE_TYPE_SYML : return "SYML";
-        
-        default              : return "undefined";
+void process_fd_init( process_t * process )
+{
+    uint32_t fd;
+
+    remote_spinlock_init( XPTR( local_cxy , &process->fd_array.lock ) );
+    process->fd_array.max       = CONFIG_PROCESS_FILE_MAX_NR;
+    process->fd_array.current   = 0;
+
+    // initialize array
+    for ( fd = 0 ; fd < process->fd_array.max ; fd++ )
+    {
+        process->fd_array.array[fd] = XPTR_NULL;
     }
 }
-   
-///////////////////////////////////////////
-void process_fd_init( process_t * process )
+
+//////////////////////////////////////////////
+void process_fd_destroy( process_t * process )
 {
     uint32_t fd;
 
-    // initialize lock
-    remote_queuelock_init( XPTR( local_cxy , &process->fd_array.lock ), LOCK_PROCESS_FDARRAY );
-
-    // initialize number of open files
-    process->fd_array.max = 0;
-
-    // initialize array
-    for ( fd = 0 ; fd < CONFIG_PROCESS_FILE_MAX_NR ; fd++ )
-    {
-        process->fd_array.array[fd] = XPTR_NULL;
+    // loop on all open file descriptors to close all open files 
+    for( fd = 0 ; fd < process->fd_array.max ; fd++ )
+    {
+        xptr_t file_xp = process->fd_array.array[fd];
+        if ( file_xp != XPTR_NULL ) vfs_close( file_xp , NULL );
     }
 }
 
-////////////////////////////////////////////////////
-error_t process_fd_register( xptr_t      process_xp,
-                             xptr_t      file_xp,
-                             uint32_t  * fdid )
+///////////////////////////////////////////////////
+bool_t process_fd_array_full( process_t * process )
+{
+	return ( process->fd_array.current >= process->fd_array.max);  
+}
+
+/////////////////////////////////////////////////
+error_t process_fd_allocate( process_t * process, 
+                             xptr_t      file_xp, 
+                             uint32_t   * ret_fd )
 {
     bool_t    found;
-    uint32_t  id;
-    uint32_t  max;             // current value of max non-free slot index
-    xptr_t    entry_xp;        // current value of one fd_array entry 
-    xptr_t    lock_xp;         // extended pointer on lock protecting fd_array
-    xptr_t    max_xp;          // extended pointer on max field in fd_array
-
-#if DEBUG_PROCESS_FD_REGISTER
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-#endif
-
-    // get target process cluster and local pointer
-    process_t * process_ptr = GET_PTR( process_xp );
-    cxy_t       process_cxy = GET_CXY( process_xp );
-
-// check target process is owner process
-assert( __FUNCTION__, (process_xp == hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp ) ) ),
-"process must be owner process\n" );
-
-#if DEBUG_PROCESS_FD_REGISTER
-pid_t  tgt_pid   = hal_remote_l32( XPTR( process_cxy , &process_ptr->pid) );
-if( DEBUG_PROCESS_FD_REGISTER < cycle )
-printk("\n[%s] thread[%x,%x] enter for process %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, tgt_pid, cycle );
-#endif
-
-    // build extended pointers on lock & max 
-    lock_xp = XPTR( process_cxy , &process_ptr->fd_array.lock );
-    max_xp  = XPTR( process_cxy , &process_ptr->fd_array.max );
-
-    // take lock protecting fd_array
-	remote_queuelock_acquire( lock_xp );
+    uint32_t  fd;
+
+	remote_spinlock_lock( XPTR( local_cxy , &process->fd_array.lock ) );
 
     found   = false;
 
-    // get current value of max_fdid
-    max = hal_remote_l32( max_xp );
-
-    for ( id = 0; id < CONFIG_PROCESS_FILE_MAX_NR ; id++ )
-    {
-        // get fd_array entry
-        entry_xp = hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[id] ) );
-        
-        // take the first empty slot
-        if ( entry_xp == XPTR_NULL )
+    for ( fd = 0; fd < process->fd_array.max; fd++ )
+    {
+        if ( process->fd_array.array[fd] == XPTR_NULL )
         {
-            // update  fd_array
-            hal_remote_s64( XPTR( process_cxy , &process_ptr->fd_array.array[id] ) , file_xp );
-
-            // update max when required
-            if( id > max ) hal_remote_s32( max_xp , id );
-
-            // exit loop
-			*fdid = id;
             found = true;
+            process->fd_array.array[fd] = file_xp;
+	        process->fd_array.current++;
+			*ret_fd = fd;
             break;
         }
     }
 
-    // release lock protecting fd_array
-	remote_queuelock_release( lock_xp );
-
-#if DEBUG_PROCESS_FD_REGISTER
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_FD_REGISTER < cycle )
-printk("\n[%s] thread[%x,%x] exit for process %x / fdid %d / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, tgt_pid, id, cycle );
-#endif
-
-    if ( !found ) return -1;
+	remote_spinlock_unlock( XPTR( local_cxy , &process->fd_array.lock ) );
+
+    if ( !found ) return EMFILE;
     else          return 0;
-
-}  // end process_fd_register()
-
-/////////////////////////////////////////////
-void process_fd_remove( xptr_t    process_xp,
-                        uint32_t  fdid )
-{
-    pid_t       pid;           // target process PID 
-    lpid_t      lpid;          // target process LPID
-    xptr_t      file_xp;       // extended pointer on file descriptor
-    xptr_t      iter_xp;       // iterator for list of process copies
-    xptr_t      copy_xp;       // extended pointer on process copy
-    process_t * copy_ptr;      // local pointer on process copy  
-    cxy_t       copy_cxy;      // process copy cluster identifier
-
-    // get target process cluster and local pointer
-    process_t * process_ptr = GET_PTR( process_xp );
-    cxy_t       process_cxy = GET_CXY( process_xp );
-
-// check target process is owner process
-assert( __FUNCTION__, (process_xp == hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp ) ) ),
-"process must be owner process\n" );
-
-    // get target process pid and lpid
-    pid  = hal_remote_l32( XPTR( process_cxy , &process_ptr->pid) );
-    lpid = LPID_FROM_PID( pid );
-
-#if DEBUG_PROCESS_FD_REMOVE
-uint32_t    cycle = (uint32_t)hal_get_cycles();
-thread_t  * this  = CURRENT_THREAD;
-if( DEBUG_PROCESS_FD_REMOVE < cycle )
-printk("\n[%s] thread[%x,%x] enter for fdid %d in process %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, fdid, pid, cycle );
-#endif
-
-    // get extended pointer on file descriptor
-    file_xp = hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[fdid] ));
-
-    // build extended pointers on list_of_copies root and lock (in owner cluster)
-    xptr_t copies_root_xp = XPTR( process_cxy , &LOCAL_CLUSTER->pmgr.copies_root[lpid] );
-    xptr_t copies_lock_xp = XPTR( process_cxy , &LOCAL_CLUSTER->pmgr.copies_lock[lpid] );
- 
-    // build extended pointer on fd_array lock and max 
-    xptr_t fd_lock_xp = XPTR( process_cxy , &process_ptr->fd_array.lock );
-    xptr_t fd_max_xp  = XPTR( process_cxy , &process_ptr->fd_array.max );
-
-    // take lock protecting fd_array
-	remote_queuelock_acquire( fd_lock_xp );
-
-    // take the lock protecting the list of copies
-    remote_queuelock_acquire( copies_lock_xp );
-
-    // get max value
-    uint32_t max = hal_remote_l32( fd_max_xp );
-
-    // loop on list of process copies
-    XLIST_FOREACH( copies_root_xp , iter_xp )
-    {
-        // get pointers on process copy
-        copy_xp  = XLIST_ELEMENT( iter_xp , process_t , copies_list );
-        copy_ptr = GET_PTR( copy_xp );
-        copy_cxy = GET_CXY( copy_xp );
-
-        // release the fd_array entry in process copy
-        hal_remote_s64( XPTR( copy_cxy , &copy_ptr->fd_array.array[fdid] ), XPTR_NULL );
-    }
-
-    // update max when required
-    if( fdid == max ) hal_remote_s32( fd_max_xp , max-1 );
-
-    // release the lock protecting fd_array
-	remote_queuelock_release( fd_lock_xp );
-
-    // release the lock protecting the list of copies
-    remote_queuelock_release( copies_lock_xp );
-
-#if DEBUG_PROCESS_FD_REMOVE
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_FD_REMOVE < cycle )
-printk("\n[%s] thread[%x,%x] exit for fdid %d in process %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, fdid, pid, cycle );
-#endif
-
-}  // end process_fd_remove()
-
-//////////////////////////////////////////////
-void process_fd_clean_all( xptr_t process_xp )
-{
-    uint32_t  fdid;
-    xptr_t    file_xp;         // one fd_array entry
-    xptr_t    lock_xp;         // extendad pointer on lock protecting fd_array
-    uint32_t  max;             // number of registered files
-
-    // get process cluster, local pointer and PID
-    process_t * process_ptr = GET_PTR( process_xp );
-    cxy_t       process_cxy = GET_CXY( process_xp );
-
-// check target process is owner process
-assert( __FUNCTION__, (process_xp == hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp )) ),
-"process must be owner process\n" );
-
-#if DEBUG_PROCESS_FD_CLEAN_ALL
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_FD_CLEAN_ALL < cycle )
-printk("\n[%s] thread[%x,%x] enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-
-process_fd_display( process_xp );
-#endif
-
-    // build extended pointer on lock protecting the fd_array
-    lock_xp = XPTR( process_cxy , &process_ptr->fd_array.lock );
-
-    // get max index for fd_array
-    max = hal_remote_l32( XPTR( process_cxy , &process_ptr->fd_array.max ));
-
-    // take lock protecting fd_array
-	remote_queuelock_acquire( lock_xp );
-
-    for( fdid = 0 ; fdid <= max ; fdid++ )
-    {
-        // get fd_array entry
-        file_xp = hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[fdid] ) );
-        
-        if ( file_xp != XPTR_NULL )
-        {
-            vfs_file_t * file_ptr = GET_PTR( file_xp );
-            cxy_t        file_cxy = GET_CXY( file_xp );
-
-            // get file type
-            uint32_t file_type = hal_remote_l32( XPTR( file_cxy , &file_ptr->type ));
- 
-            if( file_type == FILE_TYPE_REG )
-            {
-                vfs_close( file_xp , fdid );
-            }
-            if( file_type == FILE_TYPE_SOCK )
-            {
-                socket_close( file_xp , fdid );
-            }
-        }
-    }
-
-    // release lock protecting fd_array
-	remote_queuelock_release( lock_xp );
-
-#if DEBUG_PROCESS_FD_CLEAN_ALL
-cycle = (uint32_t)hal_get_cycles();
-if( DEBUG_PROCESS_FD_CLEAN_ALL < cycle )
-printk("\n[%s] thread[%x,%x] exit for process %x / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, pid, cycle );
-#endif
-
-}  // end process_fd_clean_all()
-
-//////////////////////////////////////////////////////////////
-xptr_t process_fd_get_xptr_from_owner( xptr_t      process_xp,
-                                       uint32_t    fdid )
-{
-    cxy_t       process_cxy = GET_CXY( process_xp );
-    process_t * process_ptr = GET_PTR( process_xp );
-
-assert( __FUNCTION__, (hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp )) == process_xp),
-"process_xp argument must be the owner process" );
-
-    // access owner process fd_array
-    return hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[fdid] ));
-
-}  // end process_fd_get_xptr_from_owner()
-
-///////////////////////////////////////////////////////////
-xptr_t process_fd_get_xptr_from_local( process_t * process,
-                                       uint32_t    fdid )
-{
-    xptr_t  file_xp;
-    xptr_t  lock_xp;
-
-    // access local copy of process descriptor
-    file_xp = process->fd_array.array[fdid];
-
-    if( file_xp == XPTR_NULL )
-    {
-        // get owner process cluster and local pointer
-        xptr_t      owner_xp  = process->owner_xp;
-        cxy_t       owner_cxy = GET_CXY( owner_xp );
-        process_t * owner_ptr = GET_PTR( owner_xp );
-
-        // build extended pointer on lock protecting fd_array
-        lock_xp = XPTR( owner_cxy , &owner_ptr->fd_array.lock );
-
-        // take lock protecting fd_array
-	    remote_queuelock_acquire( lock_xp );
-
-        // access owner process descriptor
-        file_xp = hal_remote_l64( XPTR( owner_cxy , &owner_ptr->fd_array.array[fdid] ) );
-
-        if( file_xp != XPTR_NULL )  
-        {
-           // update local fd_array 
-            process->fd_array.array[fdid] = file_xp;
-        }
-
-        // release lock protecting fd_array
-	    remote_queuelock_release( lock_xp );
-    }
-
-    return file_xp;
-
-}  // end process_fd_get_xptr_from_local()
-
-////////////////////////////////////////////
-error_t process_fd_replicate( xptr_t dst_xp,
-                              xptr_t src_xp )
-{
-    uint32_t fdid;      // current file descriptor index
-    xptr_t   old_xp;    // extended pointer on a file descriptor (stored in SRC fd_array) 
-    xptr_t   new_xp;    // extended pointer on a file descriptor (stored in DST fd_array)
-    error_t  error;
-
-    // get cluster and local pointer for SRC process
-    cxy_t       src_cxy = GET_CXY( src_xp );
-    process_t * src_ptr = GET_PTR( src_xp );
-
-assert( __FUNCTION__, (src_xp == hal_remote_l64( XPTR( src_cxy , &src_ptr->owner_xp ))),
-"src_xp process not in owner cluster" );
-
-    // get cluster and local pointer for DST fd_array
-    cxy_t       dst_cxy = GET_CXY( dst_xp );
-    process_t * dst_ptr = GET_PTR( dst_xp );
-
-assert( __FUNCTION__, (dst_xp == hal_remote_l64( XPTR( dst_cxy , &dst_ptr->owner_xp ))),
-"dst_xp process not in owner cluster" );
-
-    // build extende pointers on SRC fd_array lock and max fields
-    xptr_t  src_lock_xp = XPTR( src_cxy , &src_ptr->fd_array.lock );
-    xptr_t  src_max_xp  = XPTR( src_cxy , &src_ptr->fd_array.max );
-
-    // get the remote lock protecting the src fd_array
-	remote_queuelock_acquire( src_lock_xp );
- 
-    // loop on fd_array entries
-    for( fdid = 0 ; fdid <= hal_remote_l32( src_max_xp ) ; fdid++ )
-	{
-		old_xp = (xptr_t)hal_remote_l64( XPTR( src_cxy , &src_ptr->fd_array.array[fdid] ) );
-
-		if( old_xp != XPTR_NULL )
+} 
+
+////////////////////////////////////////////////
+error_t process_fd_release( process_t * process,
+                            uint32_t    fd )
+{
+    if ( (fd < 0) || (fd > process->fd_array.max) ) return EBADF;
+
+    remote_spinlock_lock( XPTR( local_cxy , &process->fd_array.lock ) );
+
+    process->fd_array.array[fd] = XPTR_NULL;
+	process->fd_array.current--;
+
+	remote_spinlock_unlock( XPTR( local_cxy , &process->fd_array.lock ) );
+
+    return 0;
+}
+
+///////////////////////////////////////
+void process_fd_copy( fd_array_t * dst,
+                      fd_array_t * src )
+{
+    uint32_t fd;
+    xptr_t   entry;
+
+    remote_spinlock_lock( XPTR( local_cxy , &src->lock ) );
+
+    // loop on all entries in source process fd_array        
+    for( fd = 0 ; fd < src->max ; fd++ )
+	{
+		entry = src->array[fd];
+
+		if( entry != XPTR_NULL )
 		{
-            // get the existing file descriptor cluster and local pointer
-            vfs_file_t * old_ptr = GET_PTR( old_xp );
-            cxy_t        old_cxy = GET_CXY( old_xp );
-
-            // get existing file attributes and local pointer on inode
-            uint32_t      attr      = hal_remote_l32( XPTR( old_cxy , &old_ptr->attr ) );
-            vfs_inode_t * inode_ptr = hal_remote_lpt( XPTR( old_cxy , &old_ptr->inode ) );
-
-            // create a new file descriptor in same cluster as the existing one
-            error = vfs_file_create( XPTR( old_cxy , inode_ptr ),
-                                     attr,
-                                     &new_xp );
-            if( error )
-            {
-
-#if DEBUG_PROCESS_ERROR
-thread_t * this  = CURRENT_THREAD;
-uint32_t   cycle = (uint32_t)hal_get_cycles();
-printk("\n[ERROR] in %s : thread[%x,%x] cannot create file descriptor / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, cycle );
-#endif
-                return -1;
-            }
-
-			// register new_xp in DST fd_array
-			hal_remote_s64( XPTR( dst_cxy , &dst_ptr->fd_array.array[fdid] ) , new_xp );
+            // increment file descriptor ref count
+            vfs_file_count_up( entry );
+
+			// copy entry in destination process fd_array
+			dst->array[fd] = entry;
 		}
 	}
 
     // release lock on source process fd_array
-	remote_queuelock_release( src_lock_xp );
-
-    return 0;
-
-}  // end process_fd_replicate()
-
-
-////////////////////////////////////
-bool_t process_fd_array_full( void )
-{
-    // get extended pointer on owner process
-    xptr_t owner_xp = CURRENT_THREAD->process->owner_xp;
-
-    // get owner process cluster and local pointer
-    process_t * owner_ptr = GET_PTR( owner_xp );
-    cxy_t       owner_cxy = GET_CXY( owner_xp );
-
-    // get number of open file descriptors from  fd_array
-    uint32_t max = hal_remote_l32( XPTR( owner_cxy , &owner_ptr->fd_array.max ));
-
-	return ( max == CONFIG_PROCESS_FILE_MAX_NR - 1 );
-}
-
-////////////////////////////////////////////
-void process_fd_display( xptr_t process_xp )
-{
-    uint32_t      fdid;
-    xptr_t        file_xp;
-    vfs_file_t *  file_ptr;
-    cxy_t         file_cxy;
-    uint32_t      file_type;
-    xptr_t        inode_xp;
-    vfs_inode_t * inode_ptr;
-
-    char          name[CONFIG_VFS_MAX_NAME_LENGTH];
-
-    // get process cluster and local pointer
-    process_t * process_ptr = GET_PTR( process_xp );
-    cxy_t       process_cxy = GET_CXY( process_xp );
-
-    // get process PID
-    pid_t  pid = hal_remote_l32( XPTR( process_cxy , &process_ptr->pid ));
-
-    // get pointers on owner process descriptor
-    xptr_t      owner_xp  = hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp ));
-    process_t * owner_ptr = GET_PTR( owner_xp );
-    cxy_t       owner_cxy = GET_CXY( owner_xp );
-
-    // get max fdid from owner process descriptor
-    uint32_t max = hal_remote_l32( XPTR( owner_cxy , &owner_ptr->fd_array.max ));
-
-    // get pointers on TXT0 chdev
-    xptr_t    txt0_xp  = chdev_dir.txt_tx[0];
-    cxy_t     txt0_cxy = GET_CXY( txt0_xp );
-    chdev_t * txt0_ptr = GET_PTR( txt0_xp );
-
-    // get extended pointer on remote TXT0 lock
-    xptr_t  lock_xp = XPTR( txt0_cxy , &txt0_ptr->wait_lock );
-
-    // get TXT0 lock 
-    remote_busylock_acquire( lock_xp );
-
-    nolock_printk("\n***** fd_array for pid %x in cluster %x / max %d *****\n",
-    pid, process_cxy, max );
-
-    for( fdid = 0 ; fdid <= max ; fdid++ )
-    {
-        // get pointers on file descriptor
-        file_xp  = hal_remote_l64( XPTR( process_cxy , &process_ptr->fd_array.array[fdid] ));
-        file_ptr = GET_PTR( file_xp );
-        file_cxy = GET_CXY( file_xp );
-
-        if( file_xp != XPTR_NULL )
-        {
-            // get file type
-            file_type = hal_remote_l32( XPTR( file_cxy , &file_ptr->type )); 
-
-            // get file name if inode exist
-            if( (file_type != FILE_TYPE_PIPE) && (file_type != FILE_TYPE_SOCK) )
-            {
-                // get inode pointers 
-                inode_ptr = hal_remote_lpt( XPTR( file_cxy , &file_ptr->inode ));
-                inode_xp  = XPTR( file_cxy , inode_ptr );
-
-                // get file name
-                vfs_inode_get_name( inode_xp , name );
-
-                // display relevant file descriptor info
-                nolock_printk(" - %d : type %s / ptr %x (%s)\n",
-                fdid, process_fd_type_str(file_type), file_ptr, name );
-            }
-            else    // PIPE or SOCK types
-            {
-                // display relevant file decriptor info
-                nolock_printk(" - %d : type %s / ptr %x\n",
-                fdid , process_fd_type_str(file_type), file_ptr );
-            }
-        }
-        else
-        {
-            nolock_printk(" - %d : empty slot\n", fdid );
-        }
-    }
-
-    // get TXT0 lock 
-    remote_busylock_acquire( lock_xp );
-
-}   // end process_fd_display()
+	remote_spinlock_unlock( XPTR( local_cxy , &src->lock ) );
+} 
+
+///////////////////////////////////////////
+void process_fd_remote_copy( xptr_t dst_xp,
+                             xptr_t src_xp )
+{
+    uint32_t fd;
+    xptr_t   entry;
+
+    // get cluster and local pointer for src fd_array
+    cxy_t        src_cxy = GET_CXY( src_xp );
+    fd_array_t * src_ptr = (fd_array_t *)GET_PTR( src_xp );
+
+    // get cluster and local pointer for dst fd_array
+    cxy_t        dst_cxy = GET_CXY( dst_xp );
+    fd_array_t * dst_ptr = (fd_array_t *)GET_PTR( dst_xp );
+
+    // get the remote lock protecting the src fd_array
+	remote_spinlock_lock( XPTR( src_cxy , &src_ptr->lock ) );
+
+    // get number of entries in fd_array
+    uint32_t max = hal_remote_lw( XPTR( src_cxy , &src_ptr->max ) );
+
+    // loop on all entries in source process fd_array        
+    for( fd = 0 ; fd < max ; fd++ )
+	{
+		entry = (xptr_t)hal_remote_lwd( XPTR( src_cxy , &src_ptr->array[fd] ) );
+
+		if( entry != XPTR_NULL )
+		{
+            // increment file descriptor ref count
+            vfs_file_count_up( entry );
+
+			// copy entry in destination process fd_array
+			hal_remote_swd( XPTR( dst_cxy , &dst_ptr->array[fd] ) , entry );
+		}
+	}
+
+    // release lock on source process fd_array
+	remote_spinlock_unlock( XPTR( src_cxy , &src_ptr->lock ) );
+} 
+
+
 
 ////////////////////////////////////////////////////////////////////////////////////
@@ -1611,22 +543,21 @@
                                  trdid_t   * trdid )
 {
-    ltid_t         ltid;
-    ltid_t         ltid_min;
-
-    bool_t         found = false;
-    lpid_t         lpid  = LPID_FROM_PID( process->pid );
- 
-// check arguments
-assert( __FUNCTION__, (process != NULL) , "process argument is NULL" );
-assert( __FUNCTION__, (thread != NULL) , "thread argument is NULL" );
-
-    // get the lock protecting th_tbl for all threads but the idle thread 
-    if( thread->type != THREAD_IDLE ) rwlock_wr_acquire( &process->th_lock );
-
-    // compute ltid_min : 0 for an user thread / 1 for a kernel thread
-    ltid_min = (lpid == 0) ? 1 : 0;
- 
-    // scan th_tbl
-    for( ltid = ltid_min ; ltid < CONFIG_THREADS_MAX_PER_CLUSTER ; ltid++ )
+    ltid_t   ltid;
+    bool_t   found;
+
+    if( process == NULL )
+    {
+        printk("\n[PANIC] in %s : process argument is NULL\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+    if( thread == NULL )
+    {
+        printk("\n[PANIC] in %s : thread argument is NULL\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // search a free slot in th_tbl[]
+    found = false;
+    for( ltid = 0 ; ltid < CONFIG_THREAD_MAX_PER_CLUSTER ; ltid++ )
     {
         if( process->th_tbl[ltid] == NULL )
